
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET LED_BUILTIN  //4
Adafruit_SSD1306 display(OLED_RESET);


int row = 80;
int car_speed;



//////////////////////////////////////////////////////////////////////////////
/////////////////////////SERIAL_COM_VARIABEL/////////////////////////////////

#define DEBUG 1
const int instCount = 2;
const char instName[instCount] = { 'R', 'S'};  // R = RPM  S = SPEED  the rest later
const char kEOL = '#';
const int kMaxCharCount = 5;
int defaultValue[instCount] = {0, 0};
int currentInst;
int valueCharCount = 0;
enum TPortState { psReadInst, psReadValue };
TPortState currentState = psReadInst;

int actValue[2] = {0, 0};

int first = 0;


void setup()

{
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.clearDisplay();
  Serial.begin(115200);

}

void loop()
{

  ///// SPEED DISPLAY
  display.setTextSize(4);
  display.setTextColor(WHITE);


  car_speed = actValue[1];


  if (car_speed < 100) {
    row = 56;
  }  if (car_speed < 10) {
    row = 80;
  }  if (car_speed > 99) {
    row = 32;
  }

    display.setCursor(row, 0);  //80 bis 10    60 ab 10  30 ab 99
    display.println(car_speed);
    display.display();
    display.clearDisplay();



}







////READ SERIAL
void serialEvent() {
  char tmpChar;
  int tmpValue;

  while (Serial.available()) {
    // if we're waiting for a Axis name, grab it here
    if (currentState == psReadInst) {
      tmpChar = Serial.read();

#ifdef DEBUG
      //   Serial.print("Motor: ");
      //  Serial.println(tmpChar);
#endif
      for (int i = 0; i < instCount; i++) {    // look for our axis in the array of axis names we set up
        if (tmpChar == instName[i]) {
          currentInst = i;                            // remember which axis we found
          currentState = psReadValue;                 // start looking for the Axis position
          defaultValue[currentInst] = 0;              // initialise the new position
          valueCharCount = 0;                         // initialise number of value chars read in
          break;
        }
      }
    }

    // if we're ready to read in the current Axis position data
    if (currentState == psReadValue) {
      while ((valueCharCount < kMaxCharCount) && Serial.available()) {
        tmpValue = Serial.read();
        if (tmpValue != kEOL) {
          tmpValue = tmpValue - 48;
          if ((tmpValue < 0) || (tmpValue > 9)) tmpValue = 0;
          defaultValue[currentInst] = defaultValue[currentInst] * 10 + tmpValue;
          valueCharCount++;
        }
        else break;
      }

      // if we've read the value delimiter, update the Axis and start looking for the next Axis name
      if (tmpValue == kEOL || valueCharCount == kMaxCharCount) {
#ifdef DEBUG
        //  Serial.print("Position: ");
        //   Serial.println(defaultValue[currentInst]);
        actValue[currentInst] = defaultValue[currentInst];

#endif

        currentState = psReadInst;
      }
    }
  }
}




